Index: trunk/source/Lib/TLibEncoder/TEncCavlc.cpp
===================================================================
--- trunk/source/Lib/TLibEncoder/TEncCavlc.cpp	(revision 951)
+++ trunk/source/Lib/TLibEncoder/TEncCavlc.cpp	(revision 964)
@@ -140,4 +140,5 @@
     WRITE_UVLC( rps->getNumberOfNegativePictures(), "num_negative_pics" );
     WRITE_UVLC( rps->getNumberOfPositivePictures(), "num_positive_pics" );
+
     Int prev = 0;
     for(Int j=0 ; j < rps->getNumberOfNegativePictures(); j++)
@@ -276,5 +277,9 @@
         pcPPS->getLayerId() != 1  )
     {
-        pcPPS->setPpsExtensionTypeFlag( PPS_EX_T_3D, false );
+#if H_MV_HLS_8_SPS_NODOC_48
+      pcPPS->setPps3dExtensionFlag( false ); 
+#else
+      pcPPS->setPpsExtensionTypeFlag( PPS_EX_T_3D, false );
+#endif
     }
   #endif
@@ -283,6 +288,35 @@
   WRITE_FLAG( 0, "pps_extension_flag" );
 #else
-  WRITE_FLAG( 1, "pps_extension_flag" );
-
+  WRITE_FLAG( 1, "pps_extension_present_flag" );
+
+#if H_MV_HLS_8_SPS_NODOC_48
+    WRITE_FLAG( pcPPS->getPpsRangeExtensionsFlag( ) ? 1 : 0 , "pps_range_extensions_flag" );
+    WRITE_FLAG( pcPPS->getPpsMultilayerExtensionFlag( ) ? 1 : 0 , "pps_multilayer_extension_flag" );
+#if !H_3D
+    WRITE_CODE( pcPPS->getPpsExtension6bits( ), 6, "pps_extension_6bits" );
+#else
+    WRITE_FLAG( pcPPS->getPps3dExtensionFlag( ) ? 1 : 0 , "pps_3d_extension_flag" );
+    WRITE_CODE( pcPPS->getPpsExtension5bits( ), 5, "pps_extension_5bits" );
+#endif
+    if ( pcPPS->getPpsRangeExtensionsFlag() )
+    { 
+      assert(0); 
+    }
+
+    if ( pcPPS->getPpsMultilayerExtensionFlag() )
+    { 
+      WRITE_FLAG( pcPPS->getPocResetInfoPresentFlag( ) ? 1 : 0 , "poc_reset_info_present_flag" );
+#if H_MV_HLS_8_PPS_NODOC_NN
+      WRITE_FLAG( 0, "pps_extension_reserved_zero_flag" );
+#endif
+    }
+
+#if H_3D
+    if( pcPPS->getPps3dExtensionFlag( )  ) // This probably needs to be aligned with Rext and SHVC
+    {
+      codePPSExtension( pcPPS ); 
+    }
+#endif
+#else
   for ( Int i = 0; i < PPS_EX_T_MAX_NUM; i++ )
   {
@@ -305,4 +339,5 @@
     codePPSExtension( pcPPS ); 
   }
+#endif
 #endif
 
@@ -822,8 +857,37 @@
   WRITE_FLAG( 0, "sps_extension_flag" );
 #else
-  WRITE_FLAG( pcSPS->getSpsExtensionFlag(), "sps_extension_flag" );
-
-  if ( pcSPS->getSpsExtensionFlag() )
-  {
+  WRITE_FLAG( pcSPS->getSpsExtensionPresentFlag(), "sps_extension_present_flag" );
+
+  if ( pcSPS->getSpsExtensionPresentFlag() )
+  {
+#if H_MV_HLS_8_SPS_NODOC_48
+    WRITE_FLAG( pcSPS->getSpsRangeExtensionsFlag( ) ? 1 : 0 , "sps_range_extensions_flag" );
+    WRITE_FLAG( pcSPS->getSpsMultilayerExtensionFlag( ) ? 1 : 0 , "sps_multilayer_extension_flag" );
+#if !H_3D
+    WRITE_CODE( pcSPS->getSpsExtension6bits( ), 6, "sps_extension_6bits" );
+#else
+    WRITE_FLAG( pcSPS->getSps3dExtensionFlag( ) ? 1 : 0 , "sps_3d_extension_flag" );
+    WRITE_CODE( pcSPS->getSpsExtension5bits( ), 5, "sps_extension_5bits" );
+#endif
+ }
+
+  if ( pcSPS->getSpsRangeExtensionsFlag() )
+  {
+    assert( 0 ); 
+  }
+
+  if ( pcSPS->getSpsMultilayerExtensionFlag() )
+  {
+    codeSPSExtension( pcSPS ); 
+  }
+
+#if H_3D
+  if ( pcSPS->getSps3dExtensionFlag() )
+  {
+    codeSPSExtension2( pcSPS, viewIndex, depthFlag  ); 
+  }
+
+#endif
+#else
     for (Int i = 0; i < PS_EX_T_MAX_NUM; i++)
     {
@@ -848,4 +912,5 @@
 #endif
   }
+#endif
 #endif
 }
@@ -890,5 +955,10 @@
 {
   WRITE_CODE( pcVPS->getVPSId(),                    4,        "vps_video_parameter_set_id" );
+#if H_MV_HLS_8_SYN_Q0041_03
+  WRITE_FLAG( pcVPS->getVpsBaseLayerInternalFlag( ) ? 1 : 0 , "vps_base_layer_internal_flag" );
+  WRITE_FLAG( 1                                             , "vps_reserved_one_bit" );
+#else
   WRITE_CODE( 3,                                    2,        "vps_reserved_three_2bits" );
+#endif
 #if H_MV
   WRITE_CODE( pcVPS->getMaxLayersMinus1(),       6,        "vps_max_layers_minus1" );
@@ -972,5 +1042,9 @@
   }
 #if H_MV
+#if H_MV_HLS_8_RPS_Q0100_36
+  WRITE_FLAG( pcVPS->getVpsExtensionFlag(),                     "vps_extension_flag" );
+#else
   WRITE_FLAG( 1,                     "vps_extension_flag" );
+#endif
   m_pcBitIf->writeAlignOne();
   codeVPSExtension( pcVPS );                           
@@ -996,5 +1070,9 @@
 Void TEncCavlc::codeVPSExtension( TComVPS *pcVPS ) 
 {
+  
+#if !H_MV_HLS_8_SYN_Q0041_03
   WRITE_FLAG( pcVPS->getAvcBaseLayerFlag() ? 1 : 0,          "avc_base_layer_flag" );
+#endif
+
   WRITE_FLAG( pcVPS->getSplittingFlag() ? 1 : 0,             "splitting_flag" );
 
@@ -1010,5 +1088,5 @@
 
   if ( pcVPS->getSplittingFlag() )
-  { // Ignore old dimension id length
+  {
     pcVPS->setDimensionIdLen( pcVPS->getNumScalabilityTypes( ) - 1 ,pcVPS->inferLastDimsionIdLenMinus1() + 1 );       
   }    
@@ -1042,5 +1120,4 @@
   }
 
-
   WRITE_CODE( pcVPS->getViewIdLen( ), 4, "view_id_len" );
 
@@ -1068,4 +1145,5 @@
     }
   }
+
   WRITE_FLAG( pcVPS->getVpsSubLayersMaxMinus1PresentFlag( ) ? 1 : 0 , "vps_sub_layers_max_minus1_present_flag" );
   if ( pcVPS->getVpsSubLayersMaxMinus1PresentFlag() )
@@ -1109,25 +1187,50 @@
   }
 
-  WRITE_UVLC( pcVPS->getNumAddOutputLayerSets( ), "num_add_output_layer_sets" );
+#if H_MV_HLS_8_SYN_39_19
+  if ( pcVPS->getNumIndependentLayers() > 1 ) 
+  {
+   WRITE_UVLC( pcVPS->getNumAddLayerSets( ), "num_add_layer_sets" );
+  }
+  for (Int i = 0; i < pcVPS->getNumAddLayerSets(); i++)
+  {
+    for (Int j = 0; j < pcVPS->getNumIndependentLayers(); j++)
+    {
+      WRITE_CODE( pcVPS->getHighestLayerIdxPlus1( i, j ), pcVPS->getHighestLayerIdxPlus1Len( j )  , "highest_layer_idx_plus1" );
+    }
+  }
+  if (pcVPS->getNumLayerSets() > 1)
+  {
+    WRITE_UVLC( pcVPS->getNumAddOlss( ), "num_add_olss" );
+    WRITE_CODE( pcVPS->getDefaultOutputLayerIdc( ), 2, "default_output_layer_idc" );
+  }
+#else
+  WRITE_UVLC( pcVPS->getNumAddLayerSets( ), "num_add_layer_sets" );
 
   if( pcVPS->getNumOutputLayerSets() > 1)
   {
-    WRITE_CODE( pcVPS->getDefaultTargetOutputLayerIdc( ), 2, "default_target_output_layer_idc" );
+    WRITE_CODE( pcVPS->getDefaultOutputLayerIdc( ), 2, "default_output_layer_idc" );
   }  
-
+#endif
 
   assert( pcVPS->getOutputLayerFlag(0, 0) == pcVPS->inferOutputLayerFlag( 0, 0 )); 
-  assert( pcVPS->getOutputLayerSetIdxMinus1( 0 ) == -1 ); 
+  assert( pcVPS->getLayerSetIdxForOlsMinus1( 0 ) == -1 ); 
+
+
+
 
   for( Int i = 1; i < pcVPS->getNumOutputLayerSets( ); i++ )
   {
+#if H_MV_HLS_8_SYN_39_19
+    if( i >= pcVPS->getNumLayerSets( ) )    
+#else
     if( i > pcVPS->getVpsNumLayerSetsMinus1( ) )    
+#endif
     {      
-      WRITE_UVLC( pcVPS->getOutputLayerSetIdxMinus1( i ),      "output_layer_set_idx_minus1[i]" );
-    }
-
-    if ( i > pcVPS->getVpsNumLayerSetsMinus1() || pcVPS->getDefaultTargetOutputLayerIdc() == 2 )
+      WRITE_UVLC( pcVPS->getLayerSetIdxForOlsMinus1( i ),      "layer_set_idx_for_ols_minus1[i]" );
+    }
+
+    if ( i > pcVPS->getVpsNumLayerSetsMinus1() || pcVPS->getDefaultOutputLayerIdc() == 2 )
     {       
-      for( Int j = 0; j < pcVPS->getNumLayersInIdList( pcVPS->getLayerSetIdxForOutputLayerSet( i ) ); j++ )
+      for( Int j = 0; j < pcVPS->getNumLayersInIdList( pcVPS->olsIdxToLsIdx( i ) ); j++ )
       {
         WRITE_FLAG( pcVPS->getOutputLayerFlag( i, j) ? 1 : 0, "output_layer_flag" );
@@ -1136,9 +1239,10 @@
     else
     {
-      for( Int j = 0; j < pcVPS->getNumLayersInIdList( pcVPS->getLayerSetIdxForOutputLayerSet( i ) ) - 1; j++ )
+      for( Int j = 0; j < pcVPS->getNumLayersInIdList( pcVPS->olsIdxToLsIdx( i ) ) - 1; j++ )
       {              
         assert( pcVPS->getOutputLayerFlag( i , j ) == pcVPS->inferOutputLayerFlag( i, j )); 
       }
     }        
+
 
     if ( pcVPS->getProfileLevelTierIdxLen()  > 0 )
@@ -1152,4 +1256,5 @@
   }
 
+#if !H_MV_HLS_8_PMS_Q0195_20
   WRITE_FLAG( pcVPS->getRepFormatIdxPresentFlag( ) ? 1 : 0 , "rep_format_idx_present_flag" );
   if ( pcVPS->getRepFormatIdxPresentFlag() )
@@ -1157,22 +1262,55 @@
     WRITE_UVLC( pcVPS->getVpsNumRepFormatsMinus1( ), "vps_num_rep_formats_minus1" );
   }
+#else
+  WRITE_UVLC( pcVPS->getVpsNumRepFormatsMinus1( ), "vps_num_rep_formats_minus1" );
+#endif
 
   for (Int i = 0; i <= pcVPS->getVpsNumRepFormatsMinus1(); i++ )
   {    
+
     TComRepFormat* curRepFormat = pcVPS->getRepFormat(i);     
     TComRepFormat* prevRepFormat = i > 0 ? pcVPS->getRepFormat( i - 1) : NULL; 
     codeRepFormat( i, curRepFormat ,  prevRepFormat); 
-  }
-
+
+  }
+
+#if H_MV_HLS_8_PMS_Q0195_20
+  if ( pcVPS->getVpsNumRepFormatsMinus1() > 0 )
+  {
+    WRITE_FLAG( pcVPS->getRepFormatIdxPresentFlag( ) ? 1 : 0 , "rep_format_idx_present_flag" );
+  }
+#endif
   if( pcVPS->getRepFormatIdxPresentFlag() ) 
   {
+#if H_MV_HLS_8_SYN_Q0041_03
+    for( Int i = pcVPS->getVpsBaseLayerInternalFlag() ? 1 : 0; i <=  pcVPS->getMaxLayersMinus1(); i++ )
+#else
     for( Int i = 1; i <=  pcVPS->getMaxLayersMinus1(); i++ )
-    {
+#endif
+    {
+#if !H_MV_HLS_8_PMS_Q0195_20
       if( pcVPS->getVpsNumRepFormatsMinus1() > 0 )
       {
+#endif
         WRITE_CODE( pcVPS->getVpsRepFormatIdx(i), pcVPS->getVpsRepFormatIdxLen(), "vps_rep_format_idx[i]" );
-      }
-    }
-  }
+#if !H_MV_HLS_8_PMS_Q0195_20
+      }
+#endif
+    }
+  }
+#if H_MV_HLS_8_PMS_Q0195_20
+  else
+  {
+#if H_MV_HLS_8_SYN_Q0041_03
+    for( Int i = pcVPS->getVpsBaseLayerInternalFlag() ? 1 : 0; i <=  pcVPS->getMaxLayersMinus1(); i++ )
+#else
+    for( Int i = 1; i <=  pcVPS->getMaxLayersMinus1(); i++ )
+#endif
+    {
+      assert( pcVPS->getVpsRepFormatIdx( i ) ==  pcVPS->inferVpsRepFormatIdx( i ) );
+    }
+  }
+#endif
+
 
   WRITE_FLAG( pcVPS->getMaxOneActiveRefLayerFlag( ) ? 1 : 0, "max_one_active_ref_layer_flag" );
@@ -1187,4 +1325,5 @@
     }
   }
+
   WRITE_FLAG( 0, "vps_reserved_zero_flag" );
   codeDpbSize( pcVPS ); 
@@ -1193,5 +1332,4 @@
 
   WRITE_FLAG( pcVPS->getDefaultDirectDependencyFlag( ) ? 1 : 0 , "default_direct_dependency_flag" );
-
   if ( pcVPS->getDefaultDirectDependencyFlag( ) )
   {  
@@ -1199,7 +1337,13 @@
   }
 
+#if H_MV_HLS_8_SYN_Q0041_03
+  for( Int i = pcVPS->getVpsBaseLayerInternalFlag() ?  1 : 2; i <= pcVPS->getMaxLayersMinus1(); i++ )
+  {
+    for( Int j = pcVPS->getVpsBaseLayerInternalFlag() ?  0 : 1; j < i; j++ )
+#else
   for( Int i = 1; i <= pcVPS->getMaxLayersMinus1(); i++ )
   {
     for( Int j = 0; j < i; j++ )
+#endif
     {
       if (pcVPS->getDirectDependencyFlag( i, j) )
@@ -1218,5 +1362,9 @@
   }  
   WRITE_UVLC( 0, "vps_non_vui_extension_length" );
-  WRITE_FLAG( pcVPS->getVpsVuiPresentFlag() ? 1 : 0 , "vps_vui_present_flag" );
+  
+
+
+
+WRITE_FLAG( pcVPS->getVpsVuiPresentFlag() ? 1 : 0 , "vps_vui_present_flag" );
   if( pcVPS->getVpsVuiPresentFlag() )
   {
@@ -1229,4 +1377,5 @@
     pcVPSVUI->inferVpsVui( true ); 
   }
+
 }
 
@@ -1248,6 +1397,13 @@
   for( Int i = 1; i < vps->getNumOutputLayerSets(); i++ )
   {  
+#if H_MV_HLS_8_MIS_Q0102_30
+    Int currLsIdx = vps->olsIdxToLsIdx( i ); 
+#endif
     WRITE_FLAG( dpbSize->getSubLayerFlagInfoPresentFlag( i ) ? 1 : 0 , "sub_layer_flag_info_present_flag" );
+#if H_MV_HLS_8_MIS_Q0102_30
+    for( Int j = 0; j  <=  vps->getMaxSubLayersInLayerSetMinus1( currLsIdx ); j++ )
+#else
     for( Int j = 0; j  <=  vps->getMaxSubLayersInLayerSetMinus1( i ); j++ )
+#endif
     {  
       if( j > 0  &&  dpbSize->getSubLayerDpbInfoPresentFlag( i, j )  )  
@@ -1257,18 +1413,13 @@
       if( dpbSize->getSubLayerDpbInfoPresentFlag( i, j ) )
       {  
-        for( Int k = 0; k < vps->getNumSubDpbs( vps->getLayerSetIdxForOutputLayerSet( i )); k++ )   
+#if H_MV_HLS_8_MIS_Q0102_30
+        for( Int k = 0; k < vps->getNumLayersInIdList( currLsIdx ); k++ )   
+#else
+        for( Int k = 0; k < vps->getNumSubDpbs( vps->olsIdxToLsIdx( i )); k++ )   
+#endif
         {
           WRITE_UVLC( dpbSize->getMaxVpsDecPicBufferingMinus1( i, k, j ), "max_vps_dec_pic_buffering_minus1" );
         }
         WRITE_UVLC( dpbSize->getMaxVpsNumReorderPics( i, j ), "max_vps_num_reorder_pics" );
-#if H_MV_HLS7_GEN
-        if( vps->getNumSubDpbs( vps->getLayerSetIdxForOutputLayerSet( i ) ) != vps->getNumLayersInIdList( vps->getLayerSetIdxForOutputLayerSet( i ) ) ) 
-        {
-          for( Int k = 0; k < vps->getNumLayersInIdList( vps->getLayerSetIdxForOutputLayerSet( i ) ); k++ )
-          {
-            WRITE_UVLC( dpbSize->getMaxVpsLayerDecPicBuffMinus1( i, k, j ), "max_vps_layer_dec_pic_buff_minus1" );
-          }
-        }
-#endif
         WRITE_UVLC( dpbSize->getMaxVpsLatencyIncreasePlus1( i, j ), "max_vps_latency_increase_plus1" );
       }
@@ -1277,5 +1428,9 @@
         if ( j > 0 )
         {
-          for( Int k = 0; k < vps->getNumSubDpbs( vps->getLayerSetIdxForOutputLayerSet( i ) ); k++ )   
+#if H_MV_HLS_8_DBP_NODOC_42
+          for( Int k = 0; k < vps->getNumLayersInIdList( vps->olsIdxToLsIdx( i ) ); k++ )   
+#else
+          for( Int k = 0; k < vps->getNumSubDpbs( vps->olsIdxToLsIdx( i ) ); k++ )   
+#endif
           {
             assert( dpbSize->getMaxVpsDecPicBufferingMinus1( i, k, j ) == dpbSize->getMaxVpsDecPicBufferingMinus1( i,k, j - 1 ) );
@@ -1285,6 +1440,6 @@
         }
       }
-    }        
-  }  
+    }
+  }
 }
 
@@ -1324,4 +1479,5 @@
   assert( pcVPSVUI ); 
 
+
   WRITE_FLAG( pcVPSVUI->getCrossLayerPicTypeAlignedFlag( ) ? 1 : 0 , "cross_layer_pic_type_aligned_flag" );
   if ( !pcVPSVUI->getCrossLayerPicTypeAlignedFlag() )
@@ -1337,7 +1493,15 @@
   if( pcVPSVUI->getBitRatePresentVpsFlag( )  ||  pcVPSVUI->getPicRatePresentVpsFlag( ) )
   {
+#if H_MV_HLS_8_SYN_Q0041_03
+    for( Int i = pcVPS->getVpsBaseLayerInternalFlag() ? 0 : 1; i  <=  pcVPS->getVpsNumLayerSetsMinus1(); i++ )
+#else
     for( Int i = 0; i  <=  pcVPS->getVpsNumLayerSetsMinus1(); i++ )
-    {
+#endif
+    {
+#if H_MV_HLS_8_MIS_Q0102_30
+      for( Int j = 0; j  <=  pcVPS->getMaxSubLayersInLayerSetMinus1( i ); j++ ) 
+#else          
       for( Int j = 0; j  <=  pcVPS->getMaxTLayers(); j++ ) 
+#endif
       {
         if( pcVPSVUI->getBitRatePresentVpsFlag( ) )
@@ -1399,5 +1563,9 @@
   if( !pcVPSVUI->getTilesNotInUseFlag() ) 
   {      
+#if H_MV_HLS_8_SYN_Q0041_03
+    for( Int i = pcVPS->getVpsBaseLayerInternalFlag() ? 0 : 1; i  <=  pcVPS->getMaxLayersMinus1(); i++ )
+#else
     for( Int i = 0; i  <=  pcVPS->getMaxLayersMinus1(); i++ )
+#endif
     {
       WRITE_FLAG( pcVPSVUI->getTilesInUseFlag( i ) ? 1 : 0 , "tiles_in_use_flag[i]" );
@@ -1407,6 +1575,9 @@
       }
     }  
-
+#if H_MV_HLS_8_SYN_Q0041_03
+    for( Int i = pcVPS->getVpsBaseLayerInternalFlag() ? 1 : 2; i  <=  pcVPS->getMaxLayersMinus1(); i++ )  
+#else
     for( Int i = 1; i  <=  pcVPS->getMaxLayersMinus1(); i++ )  
+#endif
     {
       for( Int j = 0; j < pcVPS->getNumDirectRefLayers( pcVPS->getLayerIdInNuh( i ) ) ; j++ )
@@ -1439,4 +1610,8 @@
       for( Int j = 0; j < pcVPS->getNumDirectRefLayers( pcVPS->getLayerIdInNuh( i ) ); j++ )
       {
+#if H_MV_HLS_8_SYN_Q0041_03
+        if( pcVPS->getVpsBaseLayerInternalFlag() || pcVPS->getRefLayerId( pcVPS->getLayerIdInNuh( i ), j ) > 0 )
+        {        
+#endif
         WRITE_UVLC( pcVPSVUI->getMinSpatialSegmentOffsetPlus1( i, j ), "min_spatial_segment_offset_plus1" );
         if( pcVPSVUI->getMinSpatialSegmentOffsetPlus1( i, j ) > 0 )
@@ -1448,4 +1623,7 @@
           }
         }
+#if H_MV_HLS_8_SYN_Q0041_03
+        }
+#endif
       }
     }
@@ -1495,4 +1673,9 @@
     for( Int i = 0; i < vpsVuiBspHrdP->getNumBitstreamPartitions( h ); i++ )  
     {
+#if H_MV_HLS_8_HRD_Q0101_04
+      for( Int j = 0; j < pcVPS->getNumLayersInIdList( h ); j++ )  
+      {
+        WRITE_FLAG( vpsVuiBspHrdP->getLayerInBspFlag( h, i, j ) ? 1 : 0 , "layer_in_bsp_flag" );
+#else
       for( Int j = 0; j <= pcVPS->getMaxLayersMinus1(); j++ )  
       {
@@ -1505,4 +1688,5 @@
           vpsVuiBspHrdP->setLayerInBspFlag( h, i, j, false ); // This inference seems to be missing in spec 
         }
+#endif
       }
     }
@@ -1510,12 +1694,24 @@
 
     if( vpsVuiBspHrdP->getNumBitstreamPartitions( h ) )
-    {  
-      WRITE_UVLC( vpsVuiBspHrdP->getNumBspSchedCombinations( h ), "num_bsp_sched_combinations" );
-      for( Int i = 0; i < vpsVuiBspHrdP->getNumBspSchedCombinations( h ); i++ )
+    { 
+      WRITE_UVLC( vpsVuiBspHrdP->getNumBspSchedCombinationsMinus1( h ), "num_bsp_sched_combinations_minus1" );
+#if H_MV_HLS_8_HRD_Q0182_05
+      for( Int i = 0; i <= vpsVuiBspHrdP->getNumBspSchedCombinationsMinus1( h ); i++ )
+#else
+      for( Int i = 0; i < vpsVuiBspHrdP->getNumBspSchedCombinationsMinus1( h ); i++ )
+#endif
       {
         for( Int j = 0; j < vpsVuiBspHrdP->getNumBitstreamPartitions( h ); j++ )
         {  
+#if H_MV_HLS_8_HRD_Q0101_04
+          WRITE_CODE( vpsVuiBspHrdP->getBspCombHrdIdx( h, i, j ),  vpsVuiBspHrdP->getBspCombHrdIdxLen(), "bsp_comb_hrd_idx" ); 
+#else
           WRITE_UVLC( vpsVuiBspHrdP->getBspCombHrdIdx( h, i, j ), "bsp_comb_hrd_idx" );
+#endif
           WRITE_UVLC( vpsVuiBspHrdP->getBspCombSchedIdx( h, i, j ), "bsp_comb_sched_idx" );
+
+#if H_MV_HLS_8_HRD_Q0101_04
+          vpsVuiBspHrdP->checkBspCombHrdAndShedIdx( pcVPS, h, i, j ); 
+#endif
         }  
       }
@@ -1636,5 +1832,9 @@
   if ( pcSlice->getRapPicFlag() )
   {
+#if SETTING_NO_OUT_PIC_PRIOR
+    WRITE_FLAG( pcSlice->getNoOutputPriorPicsFlag() ? 1 : 0, "no_output_of_prior_pics_flag" );
+#else
     WRITE_FLAG( 0, "no_output_of_prior_pics_flag" );
+#endif
   }
 #if PPS_FIX_DEPTH
@@ -1707,5 +1907,9 @@
       Int picOrderCntLSB = (pcSlice->getPOC()-pcSlice->getLastIDR()+(1<<pcSlice->getSPS()->getBitsForPOC())) & ((1<<pcSlice->getSPS()->getBitsForPOC())-1);
       WRITE_CODE( picOrderCntLSB, pcSlice->getSPS()->getBitsForPOC(), "slice_pic_order_cnt_lsb");
-    }
+#if H_MV_HLS_8_POC_Q0142_32
+      pcSlice->setSlicePicOrderCntLsb( picOrderCntLSB ); 
+#endif
+    }
+
 #endif
     if( !pcSlice->getIdrPicFlag() )
@@ -2137,4 +2341,8 @@
     }
 
+#if H_MV_HLS_8_POC_Q0142_32
+    pcSlice->checkPocResetIdc(); 
+#endif
+
     if( pcSlice->getPocResetIdc() !=  0 )
     {
@@ -2147,9 +2355,18 @@
       WRITE_CODE( pcSlice->getPocLsbVal( ), pcSlice->getPocLsbValLen() , "poc_lsb_val" );
     }              
-    
+#if H_MV_HLS_8_POC_Q0142_32
+    pcSlice->checkPocLsbVal(); 
+#endif
+
     if( !pcSlice->getPocMsbValRequiredFlag() /* TODO &&  pcSlice->getVPS()->getVpsPocLsbAlignedFlag() */ )
     {
       WRITE_FLAG( pcSlice->getPocMsbValPresentFlag( ) ? 1 : 0 , "poc_msb_val_present_flag" );
     }
+#if H_MV_HLS_8_POC_Q0146_15
+    else
+    {
+      assert( pcSlice->getPocMsbValPresentFlag() ==  pcSlice->inferPocMsbValPresentFlag( ) ); 
+    }
+#endif
     
     if( pcSlice->getPocMsbValPresentFlag() )
Index: trunk/source/Lib/TLibEncoder/TEncCfg.h
===================================================================
--- trunk/source/Lib/TLibEncoder/TEncCfg.h	(revision 951)
+++ trunk/source/Lib/TLibEncoder/TEncCfg.h	(revision 964)
@@ -256,4 +256,6 @@
   Int       m_cameraIsoSpeedIdc;
   Int       m_cameraIsoSpeedValue;
+  Int       m_exposureIndexIdc;
+  Int       m_exposureIndexValue;
   Int       m_exposureCompensationValueSignFlag;
   Int       m_exposureCompensationValueNumerator;
@@ -495,5 +497,5 @@
   Void      setMaxRefPicNum                 ( Int iMaxRefPicNum )           { m_iMaxRefPicNum = iMaxRefPicNum;  }
 
-  Bool      getMaxTempLayer                 ()                              { return m_maxTempLayer;              } 
+  Int       getMaxTempLayer                 ()                              { return m_maxTempLayer;              } 
   Void      setMaxTempLayer                 ( Int maxTempLayer )            { m_maxTempLayer = maxTempLayer;      }
 
@@ -753,4 +755,8 @@
   Void  setTMISEICameraIsoSpeedValue(Int b)                  {  m_cameraIsoSpeedValue = b;  }
   Int   getTMISEICameraIsoSpeedValue()                       {  return m_cameraIsoSpeedValue;  }
+  Void  setTMISEIExposureIndexIdc(Int b)                     {  m_exposureIndexIdc = b;  }
+  Int   getTMISEIExposurIndexIdc()                           {  return m_exposureIndexIdc;  }
+  Void  setTMISEIExposureIndexValue(Int b)                   {  m_exposureIndexValue = b;  }
+  Int   getTMISEIExposurIndexValue()                         {  return m_exposureIndexValue;  }
   Void  setTMISEIExposureCompensationValueSignFlag(Int b)    {  m_exposureCompensationValueSignFlag = b;  }
   Int   getTMISEIExposureCompensationValueSignFlag()         {  return m_exposureCompensationValueSignFlag;  }
